library demo;

uses
  SysUtils, v8napi;

type
  TMyClass = class(TV8UserObject)
  private
    FPropertyInt: integer;
    FPropertyStr: WideString;
  public
    function HelloFunc(RetValue: PV8Variant; Params: PV8ParamArray;
      const ParamCount: integer): boolean;
    function HelloFunc2(RetValue: PV8Variant;Params: PV8ParamArray;
      const ParamCount: integer): boolean;
    function PropertyIntGetSet(propValue: PV8Variant; Get: boolean): boolean;
    function PropertyStrGetSet(propValue: PV8Variant; Get: boolean): boolean;
    constructor Create; override;
  end;

  TMyClass2 = class(TV8UserObject)
  public
    function Hello(RetValue: PV8Variant; Params: PV8ParamArray;
      const ParamCount: integer): boolean;
  end;

{ TMyClass }

function TMyClass.HelloFunc(RetValue: PV8Variant; Params: PV8ParamArray;
  const ParamCount: integer): boolean;
 //     ,  
 //   .
 //    True
var
  i: integer;
  d: double;
  dt: TDateTime;
  w: WideString;
begin
  i := V8AsInt(@Params[1]);
  i := I * 2; //  2
  V8SetInt(@Params[1], i); //    1

  d := V8AsDouble(@Params[2]);
  d := d * 2; //  2
  V8SetDouble(@Params[2], d); //    1

  dt := V8AsDate(@Params[3]);
  dt := dt + 1; //   
  V8SetDate(@Params[3], dt); //    1

  w := V8AsPWideChar(@Params[4]);
  w := w + '    '; //    
  V8SetWString(@Params[4], w); //    1

  V8SetBool(RetValue, True); // 

  result := True;
end;

function TMyClass.HelloFunc2(RetValue: PV8Variant;Params: PV8ParamArray;
  const ParamCount: integer): boolean;
//      
//    
var
  w: WideString;
begin
  w := V8AsPWideChar(@Params[1]);
  w := w + V8AsPWideChar(@Params[2]);
  V8SetWString(RetValue,w);
  result := True;
end;

function TMyClass.PropertyIntGetSet(propValue: PV8Variant;
  Get: boolean): boolean;
begin
  if Get then // 1     
  begin
    V8SetInt(propValue, FPropertyInt);
  end else
  begin
    FPropertyInt := V8AsInt(propValue);
  end;
  result := True;
end;

function TMyClass.PropertyStrGetSet(propValue: PV8Variant;
  Get: boolean): boolean;
begin
  if Get then // 1     
  begin
    V8SetWString(propValue, FPropertyStr);
  end else
  begin
    FPropertyStr := V8AsPWideChar(propValue);
  end;
  result := True;
end;

constructor TMyClass.Create;
begin
   FPropertyInt := -1;
   FPropertyStr := '  ';
end;

{ TMyClass2 }

function TMyClass2.Hello(RetValue: PV8Variant; Params: PV8ParamArray;
  const ParamCount: integer): boolean;
begin
    V8SetWString(RetValue,' TMyClass2!   Delphi');
    result := True;
end;

begin
  //  1
  with ClassRegList.RegisterClass(TMyClass, 'MySuperExtention', 'TMyClass') do
  begin
    AddFunc('HelloFunc', '', @TMyClass.HelloFunc, 4);
    with
    AddFunc('HelloFunc2', '2', @TMyClass.HelloFunc2, 2) do
    begin
        DefParams.AddWString(' ',1);
        DefParams.AddWString(' ',2);
    end;
    AddProp('PropertyInt','',True,True,@TMyClass.PropertyIntGetSet);
    AddProp('PropertyStr','',True,True,@TMyClass.PropertyStrGetSet);
  end;

   //  2
  with ClassRegList.RegisterClass(TMyClass2, '', 'TMyClass2') do
  begin
    AddFunc('Hello', '', @TMyClass2.Hello);
  end;

end.

